package cz.upol.jj2.lab10.modules.greeter;

import cz.upol.jj2.lab10.modules.politeness.PoliteInterface;
import cz.upol.jj2.lab10.modules.politeness.PoliteClass;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Iterator;
import java.util.ServiceLoader;

/**
 * pouzivani veci importovanych z jineho modulu
 */
public class GreeterApp {
    public static void main(String[] args) throws InvocationTargetException, NoSuchMethodException, InstantiationException, IllegalAccessException {
        //klasicke pouziti pres importy
        PoliteInterface pi = new PoliteClass();
        pi.greet("classic");

        //O neco zajimavejsi pouziti pres ServiceLoader,
        //  ktery vyuziva (mimojine) informace provides ... with ... z definice modulu politeness
        //  pro nalazeni implementace daneho rozhrani.
        //Dobre pro plugin-ovy pristup
        //  t.j. nejaky modul muze poskytovat implementaci nejakeho rozrhani
        //  a my takovych modulu muzeme mit vice naraz.
        //Takto si aplikace muze vybrat, ktery provider je ten pravy...
        //v aktualnim stavu, zadny provider nenalezen -> zadny vystup
        // -> zpet do definice modulu politeness
        Iterable<PoliteInterface> services = ServiceLoader.load(PoliteInterface.class);
        Iterator<PoliteInterface> providersIterator = services.iterator();
        if(services.iterator().hasNext()) {
            PoliteInterface service = providersIterator.next();
            service.greet("service loader");
        }


        //((PoliteClass)pi).doSomething(5); //nejde, pochopitelne...

        //my uz ale zname reflexi, takze to muzeme obejit. CHACHA!
        reflectionModules();
    }

    public static void reflectionModules() throws NoSuchMethodException, InvocationTargetException, InstantiationException, IllegalAccessException {
        Class<PoliteClass> clazz = PoliteClass.class;
        PoliteClass pc = clazz.getConstructor().newInstance();

        //toto je ok
        Method mg = clazz.getDeclaredMethod("greet", String.class);
        mg.invoke(pc, "reflection");

        //OOPS - ani setAccessible nepomuze...
        Method m = clazz.getDeclaredMethod("doSomething", int.class);
        m.setAccessible(true);
        m.invoke(pc, 5);

        //co s tim? -> zpatky do definice modulu politeness
    }
}
